Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# ARC4 Class Reference

`#include <arc4.h>`

Inheritance diagram for ARC4:

List of all members.

## Detailed Description

Alleged RC4

Definition at line 35 of file arc4.h.

## Public Types
typedef SymmetricCipherFinal< ARC4_Base > | Encryption
| implements the SymmetricCipher interface
typedef SymmetricCipherFinal< ARC4_Base > | Decryption
| implements the SymmetricCipher interface
enum | IV_Requirement { STRUCTURED_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
void | SetKey (const byte *key, unsigned int length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
Clonable * | Clone () const
| this is not implemented by most classes yet
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
unsigned int | MinKeyLength () const
| returns smallest valid key length in bytes */
unsigned int | MaxKeyLength () const
| returns largest valid key length in bytes */
unsigned int | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
unsigned int | GetValidKeyLength (unsigned int n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
ARC4_Base::IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
byte | GenerateByte ()
| generate new random byte and return it
void | DiscardBytes (unsigned int n)
| generate and discard n bytes
void | ProcessData (byte *outString, const byte *inString, unsigned int length)
| encrypt or decrypt an array of bytes of specified length
bool | IsRandomAccess () const
| returns whether this cipher supports random access
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | GenerateBlock (byte *output, unsigned int size)
| generate random array of bytes
template<class IT> void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
StreamTransformation & | Ref ()
| return a reference to this object,
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | ProcessLastBlock (byte *outString, const byte *inString, unsigned int length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, unsigned int length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, unsigned int length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual void | Seek (lword n)
| for random access ciphers, seek to an absolute position
virtual bool | IsValidKeyLength (unsigned int n) const
| returns whether n is a valid key length
void | SetKeyWithRounds (const byte *key, unsigned int length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, unsigned int length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
| returns size of IVs used by this object
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
std::string | StaticAlgorithmName ()
unsigned int | StaticGetValidKeyLength (unsigned int n)
## Protected Member Functions
void | AssertValidKeyLength (unsigned int length)
void | AssertValidKeyLength (unsigned int length) const
void | UncheckedSetKey (const NameValuePairs &params, const byte *key, unsigned int length, const byte *iv)
virtual unsigned int | GetDefaultDiscardBytes () const
void | ThrowIfInvalidKeyLength (const Algorithm &algorithm, unsigned int length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
## Protected Attributes
FixedSizeSecBlock< byte, 256 > | m_state
byte | m_x
byte | m_y

## Member Function Documentation

void SymmetricCipherFinal< ARC4_Base , ARC4_Base >::SetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs`
| ) | `[inline, virtual, inherited]`

| Implements SimpleKeyingInterface. Definition at line 277 of file strciphr.h.

void ARC4_Base::DiscardBytes | ( | unsigned int | n | ) | `[virtual, inherited]`

| generate and discard n bytes Default implementation is to call GenerateByte() n times. Reimplemented from RandomNumberGenerator. Definition at line 97 of file arc4.cpp.

void ARC4_Base::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | unsigned int | length
| ) | `[virtual, inherited]`

| encrypt or decrypt an array of bytes of specified length Note: either inString == outString, or they don't overlap Implements StreamTransformation. Definition at line 68 of file arc4.cpp.

unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

| generate new random bit and return it Default implementation is to call GenerateByte() and return its parity. Reimplemented in PublicBlumBlumShub. Definition at line 111 of file cryptlib.cpp. References RandomNumberGenerator::GenerateByte().

void RandomNumberGenerator::GenerateBlock | ( | byte * | output,
|  | unsigned int | size
| ) | `[virtual, inherited]`

| generate random array of bytes Default implementation is to call GenerateByte() size times. Reimplemented in NonblockingRng, BlockingRng, and RandomPool. Definition at line 116 of file cryptlib.cpp. References RandomNumberGenerator::GenerateByte(). Referenced by DL_GroupParameters_DSA::GenerateRandom().

StreamTransformation& StreamTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object, This function is useful for passing a temporary StreamTransformation object to a function that takes a non-const reference. Definition at line 464 of file cryptlib.h.

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

| returns the input block size that is most efficient for this cipher Note: optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0 Definition at line 471 of file cryptlib.h.

void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | unsigned int | length
| ) | `[virtual, inherited]`

| for ciphers where the last block of data is special, encrypt or decrypt the last block of data For now the only use of this function is for CBC-CTS mode. Definition at line 101 of file cryptlib.cpp. References StreamTransformation::MandatoryBlockSize(), StreamTransformation::MinLastBlockSize(), and StreamTransformation::ProcessData().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

| returns whether this object can be resynchronized (i.e. supports initialization vectors) If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed. Definition at line 384 of file cryptlib.h.

virtual void SimpleKeyingInterface::GetNextIV | ( | byte * | IV | ) | `[inline, virtual, inherited]`

| get a secure IV for the next message This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects. Definition at line 400 of file cryptlib.h.

The documentation for this class was generated from the following file:

- arc4.h